'''Game main module.

DIS IS MY GAME!
By Eugman
'''

import pyglet, math, copy
from pyglet.window import key
from pyglet.window import mouse

levels=(
    (50,("input",6,13,1),("output",6,0,1)),
    (102,("input",2,13,1),("input",6,13,2),("output",3,0,1),("output",5,0,2)),
    (32,("input",5,13,1),("input",2,13,2),("output",5,0,2),("output",2,0,1)),
    (150-95,("input",5,13,1),("input",2,13,2),("input",1,13,3),("output",5,0,2),("output",2,0,1),("output",8,0,3)),
    
    (150-85,("input",1,13,1),("input",2,13,1),("input",3,13,1),("input",4,13,1),("input",7,13,3),
    ("output",2,0,3),("output",5,0,1),("output",6,0,1),("output",7,0,1),("output",8,0,1)),
    (150,("input",5,13,1),("input",2,13,2),("output",5,0,2),("output",2,0,1))
    )


##simple functions
def rectcollide((x,y),(l,w),(x2,y2)):
    """This assigns a bunch of short names for variable then does 4 comparison that are all anded together. 
    If one fails then the two rectangles are not colliding"""
    #horizontal variables

    result=x-l<=x2<=x+l and y-w<=y2<=y+w
    return result
    

def dirtocol(dir):
    d=(dir[0],dir[1])
    cols={(0,-1):(255,255,255,255),
        (0,1):(0,0,0,255),
        (-1,0):(0,0,255,255),
        (1,0):(255,0,0,255)}
    return cols[d]

def straight(dir):
    if dir==[0,1]:
        return 0
    elif dir==[1,0]:
        return 1
    elif dir==[0,-1]:
        return 2
    else:
        return 3

def mirrorstraight(dir):
    if dir==[0,1]:
        return 2
    elif dir==[1,0]:
        return 1
    elif dir==[0,-1]:
        return 0
    else:
        return 3

def sdir(c):
    e=c.ends
    if e==(1,0,0,0):
        return [0,1]
    if e==(0,1,0,0):
        return [-1,0]
    if e==(0,0,1,0):
        return [0,-1]
    if e==(0,0,0,1):
        return [1,0]



def right(c,d):
    if d==[0,1]:
        if c==(0,1,1,0):
            return True
        else: return False
    elif d==[1,0]:
        if c==(0,0,1,1):
            return True
        else: return False
    elif d==[0,-1]:
        if c==(1,0,0,1):
            return True
        else: return False
    elif d==[-1,0]:
        if c==(1,1,0,0):
            return True
        else: return False
    else: print "OH CRAP"
#def right(dir):
    #if dir==[0,1]:
        #return 1
    #elif dir==[1,0]:
        #return 2
    #elif dir==[0,-1]:
        #return 3
    #else:
        #return 0

def lerp(old,new,p):
    #returns a new 2item list based on a percentage of the new and the remainder of the old.
    
    return [x*(1-p)+y*p for x,y in zip(old,new)]
        
            
def tog(x):
    """Converts an x or a y to the grid number"""
    return (x+20)//40

def drawsquare((x,y),(l,w),color):
    pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),
        ('c4B', color*4))
    

def typecolor(t):
    #given a type numer, return the corresponding color.
    d={1:(200,200,100,240),2:(100,143,200,240),3:(227,82,60,240),4:(0,0,0,240)}
    if 0<t<=3:
        return d[t]
    else:
        return d[1]

def top(i,j):
    return [i*40+240,j*40+40]
##complicated functions
#def marksides(g):
    #for i in range(len(g)):
        #for j in range(len(g[i])):
            #if g[i][j]: g[i][j].sides=(g[i][j+1],g[i+1][j],g[i][j-1],g[i-1][j])

def checkwin(g):
    didwin=[1,]
    for i in range(1,8):
        if g[i][0]:
            didwin.append(g[i][0].color==(0,0,0,255))
    return all(didwin)
    
def makelevel(convs):
    g=[[[] for x in xrange(14)] for x in xrange(10)]
    b=[[[] for x in xrange(14)] for x in xrange(10)]
    c=convs[0]
    for i in range(1,len(convs)):
        if convs[i][0]=="input":
            g[convs[i][1]][convs[i][2]]=input(top(convs[i][1],convs[i][2]),convs[i][3])   
        elif convs[i][0]=="output":
            g[convs[i][1]][convs[i][2]]=output(top(convs[i][1],convs[i][2]),convs[i][3])
    return c,g,b
def convert(conv):
    #Rotate through the list of tiles
    
    if sum(conv.ends)==1:
        conv.ends=(0,1,0,1)
        conv.type="alter"
    elif sum(conv.ends)==2:
        conv.ends=(1,1,1,1)
        conv.type="4way"
    elif sum(conv.ends)==4:
        conv.ends=(0,0,1,0)
        conv.type="straight"
        
        
def connected(start,end,(x,y)):
    #check if two conveyors have touching ends in a certain direction.
    
    if x:
        if x==1:
            return start.ends[1] and end.ends[3]
        else:
            return start.ends[3] and end.ends[1]
    elif y:
        if y==1:
            return start.ends[0] and end.ends[2]
        else:
            return start.ends[2] and end.ends[0]
            
def produce(g,b):
    for i in range(len(g)):
        if g[i][13]:
            
            if g[i][13].out==0:
                g[i][13].out+=1
                if not b[i][13] and g[i][13].amount:
                    g[i][13].amount-=1
                    b[i][13]=square(g[i][13].pos[:],[10,10])
                    b[i][13].color=typecolor(g[i][13].typeno)
                elif not g[i][13].amount:
                    g[i][13].color=(0,0,0,255)
                else: pass
            else:
                g[i][13].out+=1
                g[i][13].out=g[i][13].out%(g[i][13].rate+1)
                
def consume(g,b):
    for i in range(len(g)):
        if g[i][0] and b[i][0]:
            if b[i][0].color==g[i][0].color:
                g[i][0].caught+=1
                if g[i][0].amount<=g[i][0].caught:
                    g[i][0].color=(0,0,0,255)
            else: pass
            b[i][0]=0
            g[i][0].full=0
                
        
def newdirection(c,d):
    #takes a conveyor and a direction and returns the new direction
    e=c.ends
    if c.type=="straight" or c.type=="input":
    
        return sdir(c)
    elif c.type=="4way" or c.type=="output":
        return d
    
    elif c.type=="alter":
        if c.right:
            
            return {(0,1):(1,0),
            (-1,0):(0,1),
            (0,-1):(-1,0),
            (1,0):(0,-1)}[(d[0],d[1])]
            
        else:
            
            return {(0,1):(-1,0),
            (-1,0):(0,-1),
            (0,-1):(1,0),
            (1,0):(0,1)}[(d[0],d[1])]
            
    else:
        print" Uh oh"
##update functions

def markempty(g,b):
    for i in range(len(g)):
        for j in range(len(g[i])):
            if g[i][j] and not b[i][j]:
                g[i][j].moved=True
            
    
def updatestatus(g,b):
    # iterate through each grid item
    for i in range(len(g)):
        for j in range(len(g[i])):
            #see if there is something here to move
            if g[i][j] and b[i][j] and not g[i][j].moved:
                x,y=b[i][j].vel#newdirection(g[i][j],b[i][j].vel)
                if g[i+x][j+y] and not g[i+x][j+y].full :#and connected(g[i][j],g[i+x][j+y],(x,y)):
                    moveblock(g,b,(i,j))
                    g[i][j].moved=True
                else: 
                    b[i][j].oldpos=b[i][j].pos[:]
                    b[i][j].vel=newdirection(g[i][j],b[i][j].vel)
                    
                    
                        
    h=sum(g,[])
    status=[x and x.moved for x in h]
    return status
    
def moveblock(g,b,(i,j)):
    x,y=b[i][j].vel#newdirection(g[i][j],b[i][j].vel)
    #set current position to old and then set new to 40 pixels in the old direction
    b[i][j].oldpos=b[i][j].pos[:]
    b[i][j].pos[0]+=40*x
    b[i][j].pos[1]+=40*y
    #copy the block over, clear the olf spot, amrk the old grid as empty, and the new as full
    b[i+x][j+y]=copy.copy(b[i][j])
    b[i][j]=0
    g[i][j].full=0
    g[i+x][j+y].full=1
    #update direction
    b[i+x][j+y].oldvel=b[i+x][j+y].vel[:]
    
    
    b[i+x][j+y].vel=newdirection(g[i+x][j+y],b[i+x][j+y].vel)
    #flip flipper and update color
    g[i][j].right=not g[i][j].right
    g[i+x][j+y].sides[mirrorstraight([x,y])]=1
    #b[i+x][j+y].color=dirtocol(b[i+x][j+y].vel)
    
def resetstatus(g,b):
    #For all of the tiles, clear the moved switch
     for i in range(len(g)):
        for j in range(len(g[i])):
            if g[i][j]: g[i][j].moved=False   






############3
##Classes
##############

class square(object):
    """ the base class for moving blocks"""
    def __init__(self,pos,(x,y)):
        self.vel=[0,-1]
        self.oldvel=self.vel[:]
        self.pos=pos
        self.oldpos=pos[:]
        self.lw=[x,y]
        self.color=(200,200,128,255)
        self.ticks=0
    def draw(self):
        drawsquare(lerp(self.oldpos,self.pos,self.ticks/30.0),self.lw,self.color)
    def update(self,dt,ticks):
        self.ticks=ticks
        

class overl(square):
    """Class for the overlay that doesn't deal with oldpos"""
    def draw(self):
        drawsquare(self.pos,self.lw,self.color)


class conveyor(object):
    """The base class for a converyor, it takes no parameters"""
    def __init__(self):
        self.ends=(0,0,1,0)
        self.sides=[0,0,0,0]
        self.color=(0,0,0,255)
        self.pos=[-100,-100]
        self.HASBOX=False
        self.full=0
        self.right=True
        self.moved=False
        #self.turned=False
        self.type="straight"
        
    def draw(self):
        for i in range(4):
            if self.sides[i]:
                if i%2:
                    #Right or Left
                    l=11
                    w=2.5
                    x=self.pos[0]+(i-2)*9
                    y=self.pos[1]
                else:
                    #Top or bottom
                    l=2.5
                    w=11
                    x=self.pos[0]
                    y=self.pos[1]+(i-1)*-9
                pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',
                (x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),('c4B', (152,152,152,255)*4))
        if self.HASBOX:
            drawsquare(self.pos,(15,15),self.color)
        #draw a box for each of the ends
        
        for i in range(4):
            if self.ends[i]:
                if i%2:
                    #Right or Left
                    l=11
                    w=2.5
                    x=self.pos[0]+(i-2)*9
                    y=self.pos[1]
                else:
                    #Top or bottom
                    l=2.5
                    w=11
                    x=self.pos[0]
                    y=self.pos[1]+(i-1)*-9
                pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),('c4B', (255,255,255,255)*4))
        if self.type=="alter":
            for i in range(4):
                if self.ends[i] and ((self.right and (i==0 or i==3)) or (not self.right and (i==1 or i==2))):
                    if i%2:
                        #Right or Left
                        l=11
                        w=2.5
                        x=self.pos[0]+(i-2)*9
                        y=self.pos[1]
                    else:
                        #Top or bottom
                        l=2.5
                        w=11
                        x=self.pos[0]
                        y=self.pos[1]+(i-1)*-9
                    pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',
                    (x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),('c4B', (50,50,50,255)*4))
    def update(self,dt,ticks):
        pass
    def rotate(self,direction):
        if direction==1:
            self.ends=self.ends[-1:]+self.ends[:-1]
        elif direction==-1:
            self.ends=self.ends[1:]+self.ends[:1]

class input(conveyor):
    def __init__(self,pos,typeno=1):
        self.pos=pos
        self.typeno=typeno
        self.type="input"
        self.ends=(0,0,1,0)
        self.color=typecolor(self.typeno)
        self.full=0
        self.rate=1
        self.out=0
        self.amount=8
        self.HASBOX=True
        self.moved=False
        self.right=True
        self.sides=[0,0,0,0]
        

class output(conveyor):
    def __init__(self,pos,typeno=1):
        self.pos=pos
        self.typeno=typeno
        self.type="output"
        self.ends=(1,0,0,0)
        self.color=typecolor(self.typeno)
        self.full=0
        self.amount=8
        self.caught=0
        self.HASBOX=True
        self.moved=False
        self.right=True
        self.sides=[0,0,0,0]
    




#######################
##Main
########################33
def main():
    
    
    
    
    window=pyglet.window.Window(800,600,"Quadrangles of Fury")
    window.levelno=0
    window.strings,window.grid,window.blocks=makelevel(levels[window.levelno])
    mouseblock=conveyor()
    overlay=overl([-100,-100],[20,20])
    
    ff = pyglet.text.Label('Fast Forward',
                          font_name='Times New Roman',
                          font_size=24,
                          x=120, y=320,
                          anchor_x='center', anchor_y='center')
    strings = pyglet.text.Label("Length Left: "+str(window.strings),
                          font_name='Times New Roman',
                          font_size=24,
                          x=690, y=540,
                          anchor_x='center', anchor_y='center')
    skiplevel = pyglet.text.Label("Skip Level",
                          font_name='Times New Roman',
                          font_size=24,
                          x=120, y=400,
                          anchor_x='center', anchor_y='center')
    restart = pyglet.text.Label("Restart",
                          font_name='Times New Roman',
                          font_size=24,
                          x=120, y=240,
                          anchor_x='center', anchor_y='center')
                          
    intro = pyglet.text.Label("Welcome to Quadrangles of Fury, the factory manager training program. As this program is SERIOUS BUSINESS, no music or sounds have been included. This program will train you to run a design the layout of a block factory. Get the blocks from the top to the bottom given a limited length of string. Use the mouse to place and remove pieces, wasd or arrows to change the current piece. Read the Readme for more info. Good Luck!",
                          font_name='Times New Roman',
                          font_size=14,
                          x=690, y=280,
                          anchor_x='center', anchor_y='center',multiline=True,width=200)
    winner = pyglet.text.Label("",
                          font_name='Times New Roman',
                          font_size=36,
                          x=120, y=550,
                          anchor_x='center', anchor_y='center',color=(200,255,200,255))
    pyglet.ticks=1
    pyglet.ff=1
    window.skip=False
    #set the blend function and enable it
    pyglet.gl.glBlendFunc(pyglet.gl.GL_SRC_ALPHA, pyglet.gl.GL_ONE_MINUS_SRC_ALPHA)
    pyglet.gl.glEnable(pyglet.gl.GL_BLEND)
    
    @window.event
    def on_key_press(symbol,modifiers):
        #turn the tile
        if symbol==key.D or symbol==key.RIGHT:
            mouseblock.rotate(-1)
        if  symbol==key.A or symbol==key.LEFT:
            mouseblock.rotate(1)
        #go through the list of tiles
        if symbol==key.W or symbol==key.UP:
            convert(mouseblock)
        elif symbol==key.S or symbol==key.DOWN:
            convert(mouseblock)
            convert(mouseblock)
            
    
    @window.event
    def on_mouse_press(x, y, button, modifiers):
        #if in range, add a tile if empty or remove a tile.
        if 0<tog(x)-6<=8 and 0<tog(y)-1<=12:
            if button==mouse.LEFT:
                if not window.grid[tog(x)-6][tog(y)-1] and window.strings>=sum(mouseblock.ends):
                    window.grid[tog(x)-6][tog(y)-1]=copy.deepcopy(mouseblock)
                    window.strings-=sum(mouseblock.ends)
                    strings.text="Length left: "+str(window.strings)
                    
            if button==mouse.RIGHT :
                if window.grid[tog(x)-6][tog(y)-1] and not window.grid[tog(x)-6][tog(y)-1].full and not sum(window.grid[tog(x)-6][tog(y)-1].sides):
                    window.strings+=sum(window.grid[tog(x)-6][tog(y)-1].ends)
                    strings.text="Length left: "+str(window.strings)
                    window.grid[tog(x)-6][tog(y)-1]=0
        elif rectcollide((120,320),(90,24),(x,y)):
            pyglet.ff=3-pyglet.ff
            ff.text={"Fast Forward":"Slow Down","Slow Down":"Fast Forward"}[ff.text]
        elif rectcollide((120,400),(90,24),(x,y)):
            window.skip=True
        elif rectcollide((120,240),(90,24),(x,y)):    
            window.strings,window.grid,window.blocks=makelevel(levels[window.levelno])
            strings.text="Length left: "+str(window.strings)


    @window.event
    def on_mouse_motion(x,y,dx,dy):
        mouseblock.pos=[40*(tog(x)),40*(tog(y))]
        overlay.pos=mouseblock.pos
        if rectcollide((120,320),(90,24),(x,y)):
            ff.color=(255,255,255,200)
        else:
            ff.color=(255,255,255,255)
        if rectcollide((120,400),(90,24),(x,y)):
            skiplevel.color=(255,255,255,200)
        else:
            skiplevel.color=(255,255,255,255)
        if rectcollide((120,240),(90,24),(x,y)):
            restart.color=(255,255,255,200)
        else:
            restart.color=(255,255,255,255)





    ##################3
    ##DRAW
    ###################3
  
    @window.event
    def on_draw():
        window.clear()
        #draw background
        drawsquare((400,300),(400,300),(20,20,50,255))
        drawsquare((420,300),(160,240),(75,173,75,255))
        drawsquare((420,560),(160,20),(168,233,251,255))
        drawsquare((420,40),(160,20),(168,233,251,255))
        
        #draw the gird
        for i in range(len(window.grid)):
            for j in range(len(window.grid[i])):
                if window.grid[i][j]: 
                    window.grid[i][j].draw()
                else: #draw the overlay
                    if 0<i<=8:
                        drawsquare((i*40+240,j*40+40),(20,20),(50+i,50+j,50+i+j,128))
        #draw the blocks
        for i in window.blocks:
            for j in i:
                if j:j.draw()
        #if in range, draw the mouse block and overlay
        if 0<tog(mouseblock.pos[0])-6<=8 and 0<=tog(mouseblock.pos[1])-1<=13:
            overlay.draw()
            mouseblock.draw()
        ff.draw()
        skiplevel.draw()
        strings.draw()
        restart.draw()
        intro.draw()
        winner.draw()
    ##################33
    ##UPDATE
    ####################3
    
    def update(dt):
        #update ticks
        pyglet.ticks+=pyglet.ff
        pyglet.ticks=min(pyglet.ticks,30)
        pyglet.ticks%=30
        
        #Go through each grid item, update the corresponding block with new ticks,
        for i in window.blocks:
            for j in i:
                if j: j.update(dt,pyglet.ticks)
        if not pyglet.ticks:
            
            consume(window.grid,window.blocks)
            produce(window.grid,window.blocks)
            markempty(window.grid,window.blocks)
            
            oldstatus=[]
            newstatus=[1,1]
            while oldstatus!=newstatus:
                oldstatus=newstatus[:]
                newstatus=updatestatus(window.grid,window.blocks)
            
            resetstatus(window.grid,window.blocks)
            if checkwin(window.grid):
                window.levelno+=1
                if window.levelno>4:
                    window.levelno=0
                    winner.text="YOU WON!"
                window.skip=False
                window.strings,window.grid,window.blocks=makelevel(levels[window.levelno])
                strings.text="Length left: "+str(window.strings)
                
        if window.skip:
                window.levelno+=1
                if window.levelno>4:
                    window.levelno=0
                    winner.text="YOU WON!"
                window.skip=False
                window.strings,window.grid,window.blocks=makelevel(levels[window.levelno])
                strings.text="Length left: "+str(window.strings)
                
        #if the mouse is out of bounds or there is already a tile there, change the overlay color to red
        if  not 0<tog(mouseblock.pos[0])-6<=8 or  not 0<tog(mouseblock.pos[1])-1<=12 or\
         window.grid[tog(mouseblock.pos[0])-6][tog(mouseblock.pos[1])-1] or window.strings<sum(mouseblock.ends):
            overlay.color=(250,100,100,200)
        else:
            overlay.color=(128,128,255,96)
            
 
                
                
    pyglet.clock.schedule_interval(update, 1/30.)
    pyglet.app.run()

if __name__ == '__main__':
    main()
    
